var expandSubGrid = false;

var selectedRows = [];

/**
 * Agrega  elimina filas seleccionadas
 * @param row_ids
 * @param status
 * @param grid
 */

function updateSelRows(row_ids, status, grid) {
    if(status) { //si estoy seleccionando guardo en selectedRows
        for(i in row_ids) {
            if( selectedRows.indexOf(row_ids[i]) == -1 ) {
                selectedRows.push(row_ids[i]);
            }
        }
    } else { //si estoy deseleccionando lo elimino de selectedRows
        for(i in row_ids){
            selectedRows.splice(selectedRows.indexOf(row_ids[i]), 1);
        }
    }
}

/**
 * Selecciona filas en grilla
 */
$.fn.selectRows = function() {
    //recorro selectedRows y voy seleccionado una a una solo si esta presente en la grilla
    for (i=0; i < selectedRows.length; i++) {
        is_empty = isEmpty( $(this).getRowData(selectedRows[i]) );
        if( !is_empty ) $(this).setSelection(selectedRows[i], false);
    }
}
/**
 * Indica si un objeto esta vacio o no
 * @param obj
 */
function isEmpty(obj) {
    for(var prop in obj) {
        if(obj.hasOwnProperty(prop)){
            return false;
        }
    }
    return true;
}

function subgrid_setup(subgrid_id) {
    window.subgrid_table_id = "sub" + subgrid_id + "_t";
    window.pager_id = "p_" + subgrid_table_id;
    $("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='scroll'></table><div id='" + pager_id + "' class='scroll'></div>");    
}

function set_classes() {
    $(document).ready(function() {
        /* Add tooltips */
        $('.navtable .ui-pg-button').tooltip({
            container : 'body'
        });

        // remueve clase ui-icon de botón expandir, al expandir grilla
        $('.sgcollapsed').on('click', function() {
            $(this).find('span').removeClass('ui-icon');
        });

        // remove classes
        $(".ui-jqgrid").removeClass("ui-widget ui-widget-content");
        $(".ui-jqgrid-view").children().removeClass("ui-widget-header ui-state-default");
        $(".ui-jqgrid-labels, .ui-search-toolbar").children().removeClass("ui-state-default ui-th-column ui-th-ltr");
        $(".ui-jqgrid-pager").removeClass("ui-state-default");
        $(".ui-jqgrid").removeClass("ui-widget-content");

        // add classes
        $(".ui-jqgrid-htable").addClass("table table-bordered table-hover");
        $(".ui-jqgrid-btable").addClass("table table-bordered table-striped");
        $(".ui-pg-div").removeClass().addClass("btn btn-sm btn-primary");
        $("#jqgrid_pager .ui-icon").removeClass("ui-icon");
        $(".ui-icon").removeClass("ui-icon");
        $(".s-ico>span").addClass("ui-icon");
        $(".ui-icon-plus").removeClass().addClass("fa fa-plus");
        $(".ui-icon-minus").removeClass().addClass("fa fa-minus");
        $(".ui-icon-pencil").removeClass().addClass("fa fa-pencil");
        $(".ui-icon-trash").removeClass().addClass("fa fa-trash-o");
        $(".ui-icon-search").removeClass().addClass("fa fa-search");
        $(".ui-icon-refresh").removeClass().addClass("fa fa-refresh");
        $(".ui-icon-disk").removeClass().addClass("fa fa-save").parent(".btn-primary").removeClass("btn-primary").addClass("btn-success");
        $(".ui-icon-cancel").removeClass().addClass("fa fa-times").parent(".btn-primary").removeClass("btn-primary").addClass("btn-danger");
        $("td[id*='_eliminar']>div, td[id$='_anular']>div, td[id$='_desactivar']>div").removeClass("btn-primary").addClass("btn-danger");
        $("td[id*='_enviar']>div").removeClass("btn-primary").addClass("btn-success");
        $("td[id*='_descargar']>div").removeClass("btn-primary").addClass("btn-warning");

        $(".ui-icon-seek-prev").wrap("<div class='btn btn-sm btn-default'></div>");
        $(".ui-icon-seek-prev").removeClass().addClass("fa fa-backward");

        $(".ui-icon-seek-first").wrap("<div class='btn btn-sm btn-default'></div>");
        $(".ui-icon-seek-first").removeClass().addClass("fa fa-fast-backward");

        $(".ui-icon-seek-next").wrap("<div class='btn btn-sm btn-default'></div>");
        $(".ui-icon-seek-next").removeClass().addClass("fa fa-forward");

        $(".ui-icon-seek-end").wrap("<div class='btn btn-sm btn-default'></div>");
        $(".ui-icon-seek-end").removeClass().addClass("fa fa-fast-forward");
    });
}

$(document).ready(function() {
    pageSetUp();
    set_classes();
    
    $(window).on('resize.jqGrid', function() {
        if (!fullscreen) {
            $('table[id^=jqgrid]').jqGrid('setGridWidth', $(".widget-body").eq(0).width());
            $('table[id^=subjqgrid]').jqGrid('setGridWidth', $(".widget-body").eq(0).width() - 24);
        }
    });
});